=== modified file 'cronscripts/update-pkgcache.py'
--- cronscripts/update-pkgcache.py	2011-08-23 08:07:50 +0000
+++ cronscripts/update-pkgcache.py	2011-08-23 08:33:15 +0000
@@ -67,8 +67,8 @@
         DistroSeriesPackageCache.removeOld(
             distroseries, archive=archive, log=self.logger)
 
-        updates = distroseries.updateCompletePackageCache(
-            archive=archive, ztm=self.txn, log=self.logger)
+        updates = DistroSeriesPackageCache.updateAll(
+            distroseries, archive=archive, ztm=self.txn, log=self.logger)
 
         if updates > 0:
             self.txn.commit()

=== modified file 'lib/lp/registry/interfaces/distroseries.py'
--- lib/lp/registry/interfaces/distroseries.py	2011-08-23 08:07:50 +0000
+++ lib/lp/registry/interfaces/distroseries.py	2011-08-23 08:33:15 +0000
@@ -739,30 +739,6 @@
         distribution 'main_archive'.
         """
 
-    def updateCompletePackageCache(archive, log, ztm, commit_chunk=500):
-        """Update the binary package cache
-
-        Consider all binary package names published in this distro series
-        and entirely skips updates for disabled archives
-
-        :param archive: target `IArchive`;
-        :param log: logger object for printing debug level information;
-        :param ztm:  transaction used for partial commits, every chunk of
-            'commit_chunk' updates is committed;
-        :param commit_chunk: number of updates before commit, defaults to 500.
-
-        :return the number of packages updated.
-        """
-
-    def updatePackageCache(binarypackagename, archive, log):
-        """Update the package cache for a given IBinaryPackageName
-
-        'log' is required, it should be a logger object able to print
-        DEBUG level messages.
-        'ztm' is the current trasaction manager used for partial commits
-        (in full batches of 100 elements)
-        """
-
     def searchPackages(text):
         """Search through the packge cache for this distroseries and return
         DistroSeriesBinaryPackage objects that match the given text.

=== modified file 'lib/lp/registry/model/distroseries.py'
--- lib/lp/registry/model/distroseries.py	2011-08-23 08:07:50 +0000
+++ lib/lp/registry/model/distroseries.py	2011-08-23 08:33:15 +0000
@@ -1341,92 +1341,6 @@
             return section
         raise NotFoundError(name)
 
-    def updateCompletePackageCache(self, archive, log, ztm, commit_chunk=500):
-        """See `IDistroSeries`."""
-        # Do not create cache entries for disabled archives.
-        if not archive.enabled:
-            return
-
-        # Get the set of package names to deal with.
-        bpns = IStore(BinaryPackageName).find(
-            BinaryPackageName,
-            DistroArchSeries.distroseries == self,
-            BinaryPackagePublishingHistory.distroarchseriesID ==
-                DistroArchSeries.id,
-            BinaryPackagePublishingHistory.archive == archive,
-            BinaryPackagePublishingHistory.binarypackagereleaseID ==
-                BinaryPackageRelease.id,
-            BinaryPackageRelease.binarypackagename == BinaryPackageName.id,
-            BinaryPackagePublishingHistory.dateremoved == None).config(
-                distinct=True).order_by(BinaryPackageName.name)
-
-        number_of_updates = 0
-        chunk_size = 0
-        for bpn in bpns:
-            log.debug("Considering binary '%s'" % bpn.name)
-            self.updatePackageCache(bpn, archive, log)
-            number_of_updates += 1
-            chunk_size += 1
-            if chunk_size == commit_chunk:
-                chunk_size = 0
-                log.debug("Committing")
-                ztm.commit()
-
-        return number_of_updates
-
-    def updatePackageCache(self, binarypackagename, archive, log):
-        """See `IDistroSeries`."""
-
-        # get the set of published binarypackagereleases
-        bprs = IStore(BinaryPackageRelease).find(
-            BinaryPackageRelease,
-            BinaryPackageRelease.binarypackagename == binarypackagename,
-            BinaryPackageRelease.id ==
-                BinaryPackagePublishingHistory.binarypackagereleaseID,
-            BinaryPackagePublishingHistory.distroarchseriesID ==
-                DistroArchSeries.id,
-            DistroArchSeries.distroseries == self,
-            BinaryPackagePublishingHistory.archive == archive,
-            BinaryPackagePublishingHistory.dateremoved == None)
-        bprs = bprs.order_by(Desc(BinaryPackageRelease.datecreated))
-        bprs = bprs.config(distinct=True)
-
-        if bprs.count() == 0:
-            log.debug("No binary releases found.")
-            return
-
-        # find or create the cache entry
-        cache = DistroSeriesPackageCache.selectOne("""
-            distroseries = %s AND
-            archive = %s AND
-            binarypackagename = %s
-            """ % sqlvalues(self, archive, binarypackagename))
-        if cache is None:
-            log.debug("Creating new binary cache entry.")
-            cache = DistroSeriesPackageCache(
-                archive=archive,
-                distroseries=self,
-                binarypackagename=binarypackagename)
-
-        # make sure the cached name, summary and description are correct
-        cache.name = binarypackagename.name
-        cache.summary = bprs[0].summary
-        cache.description = bprs[0].description
-
-        # get the sets of binary package summaries, descriptions. there is
-        # likely only one, but just in case...
-
-        summaries = set()
-        descriptions = set()
-        for bpr in bprs:
-            log.debug("Considering binary version %s" % bpr.version)
-            summaries.add(bpr.summary)
-            descriptions.add(bpr.description)
-
-        # and update the caches
-        cache.summaries = ' '.join(sorted(summaries))
-        cache.descriptions = ' '.join(sorted(descriptions))
-
     def searchPackages(self, text):
         """See `IDistroSeries`."""
 

=== modified file 'lib/lp/soyuz/doc/distroarchseriesbinarypackage.txt'
--- lib/lp/soyuz/doc/distroarchseriesbinarypackage.txt	2011-03-23 16:28:51 +0000
+++ lib/lp/soyuz/doc/distroarchseriesbinarypackage.txt	2011-08-23 08:33:15 +0000
@@ -209,8 +209,10 @@
   DEBUG Considering source 'pmount'
   ...
 
-  >>> warty.updateCompletePackageCache(
-  ...    archive=cprov.archive, ztm=LaunchpadZopelessLayer.txn,
+  >>> from lp.soyuz.model.distroseriespackagecache import (
+  ...     DistroSeriesPackageCache)
+  >>> DistroSeriesPackageCache.updateAll(
+  ...    warty, archive=cprov.archive, ztm=LaunchpadZopelessLayer.txn,
   ...    log=FakeLogger())
   DEBUG Considering binary 'mozilla-firefox'
   ...

=== modified file 'lib/lp/soyuz/doc/package-cache.txt'
--- lib/lp/soyuz/doc/package-cache.txt	2011-08-23 08:07:50 +0000
+++ lib/lp/soyuz/doc/package-cache.txt	2011-08-23 08:33:15 +0000
@@ -260,8 +260,9 @@
 
 We can invoke the cache updater directly on IDistroSeries:
 
-  >>> updates = warty.updateCompletePackageCache(
-  ...    archive=ubuntu.main_archive, ztm=transaction, log=FakeLogger())
+  >>> updates = DistroSeriesPackageCache.updateAll(
+  ...    warty, archive=ubuntu.main_archive, ztm=transaction,
+  ...    log=FakeLogger())
   DEBUG Considering binary 'at'
   ...
   DEBUG Considering binary 'cdrkit'
@@ -362,8 +363,9 @@
   DEBUG Considering source 'pmount'
   ...
 
-  >>> binary_updates = warty.updateCompletePackageCache(
-  ...    archive=cprov.archive, ztm=transaction, log=FakeLogger())
+  >>> binary_updates = DistroSeriesPackageCache.updateAll(
+  ...    warty, archive=cprov.archive, ztm=transaction,
+  ...    log=FakeLogger())
   DEBUG Considering binary 'mozilla-firefox'
   ...
 
@@ -708,8 +710,8 @@
     ...     for series in ubuntu.series:
     ...         DistroSeriesPackageCache.removeOld(
     ...             series, archive=archive, log=logger)
-    ...         series.updateCompletePackageCache(
-    ...             archive=archive, ztm=transaction, log=logger)
+    ...         DistroSeriesPackageCache.updateAll(
+    ...             series, archive=archive, ztm=transaction, log=logger)
     ...     archive.updateArchiveCache()
     >>> def print_caches(archive):
     ...     source_caches = DistributionSourcePackageCache.selectBy(

=== modified file 'lib/lp/soyuz/model/archive.py'
--- lib/lp/soyuz/model/archive.py	2011-08-02 13:42:46 +0000
+++ lib/lp/soyuz/model/archive.py	2011-08-23 08:33:15 +0000
@@ -189,7 +189,6 @@
 from lp.soyuz.model.distributionsourcepackagecache import (
     DistributionSourcePackageCache,
     )
-from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.model.files import (
     BinaryPackageFile,
     SourcePackageReleaseFile,
@@ -910,6 +909,8 @@
 
     def updateArchiveCache(self):
         """See `IArchive`."""
+        from lp.soyuz.model.distroseriespackagecache import (
+            DistroSeriesPackageCache)
         # Compiled regexp to remove puntication.
         clean_text = re.compile('(,|;|:|\.|\?|!)')
 

=== modified file 'lib/lp/soyuz/model/distributionsourcepackagerelease.py'
--- lib/lp/soyuz/model/distributionsourcepackagerelease.py	2011-05-19 14:15:19 +0000
+++ lib/lp/soyuz/model/distributionsourcepackagerelease.py	2011-08-23 08:33:15 +0000
@@ -43,7 +43,6 @@
 from lp.soyuz.model.binarypackagename import BinaryPackageName
 from lp.soyuz.model.binarypackagerelease import BinaryPackageRelease
 from lp.soyuz.model.distroseriesbinarypackage import DistroSeriesBinaryPackage
-from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.model.publishing import (
     BinaryPackagePublishingHistory,
     SourcePackagePublishingHistory,
@@ -165,6 +164,8 @@
         #avoid circular imports.
         from lp.registry.model.distroseries import DistroSeries
         from lp.soyuz.model.distroarchseries import DistroArchSeries
+        from lp.soyuz.model.distroseriespackagecache import (
+            DistroSeriesPackageCache)
         store = getUtility(IStoreSelector).get(MAIN_STORE, DEFAULT_FLAVOR)
         archive_ids = list(self.distribution.all_distro_archive_ids)
         result_row = (

=== modified file 'lib/lp/soyuz/model/distroarchseriesbinarypackage.py'
--- lib/lp/soyuz/model/distroarchseriesbinarypackage.py	2010-11-09 08:43:34 +0000
+++ lib/lp/soyuz/model/distroarchseriesbinarypackage.py	2011-08-23 08:33:15 +0000
@@ -26,7 +26,6 @@
 from lp.soyuz.model.distroarchseriesbinarypackagerelease import (
     DistroArchSeriesBinaryPackageRelease,
     )
-from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.model.publishing import BinaryPackagePublishingHistory
 
 
@@ -76,6 +75,8 @@
     @cachedproperty
     def cache(self):
         """See IDistroArchSeriesBinaryPackage."""
+        from lp.soyuz.model.distroseriespackagecache import (
+            DistroSeriesPackageCache)
         query = """
             distroseries = %s AND
             archive IN %s AND

=== modified file 'lib/lp/soyuz/model/distroseriesbinarypackage.py'
--- lib/lp/soyuz/model/distroseriesbinarypackage.py	2011-05-18 14:32:04 +0000
+++ lib/lp/soyuz/model/distroseriesbinarypackage.py	2011-08-23 08:33:15 +0000
@@ -21,7 +21,6 @@
     IDistroSeriesBinaryPackage,
     )
 from lp.soyuz.model.binarypackagerelease import BinaryPackageRelease
-from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.model.distroseriessourcepackagerelease import (
     DistroSeriesSourcePackageRelease,
     )
@@ -66,6 +65,8 @@
     @cachedproperty
     def cache(self):
         """See IDistroSeriesBinaryPackage."""
+        from lp.soyuz.model.distroseriespackagecache import (
+            DistroSeriesPackageCache)
         store = Store.of(self.distroseries)
         archive_ids = (
             self.distroseries.distribution.all_distro_archive_ids)

=== modified file 'lib/lp/soyuz/model/distroseriespackagecache.py'
--- lib/lp/soyuz/model/distroseriespackagecache.py	2011-08-23 08:07:50 +0000
+++ lib/lp/soyuz/model/distroseriespackagecache.py	2011-08-23 08:33:15 +0000
@@ -12,7 +12,10 @@
     ForeignKey,
     StringCol,
     )
-from storm.locals import RawStr
+from storm.locals import (
+    Desc,
+    RawStr,
+    )
 from zope.interface import implements
 
 from canonical.database.sqlbase import (
@@ -24,6 +27,9 @@
     IDistroSeriesPackageCache,
     )
 from lp.soyuz.model.binarypackagename import BinaryPackageName
+from lp.soyuz.model.binarypackagerelease import BinaryPackageRelease
+from lp.soyuz.model.distroarchseries import DistroArchSeries
+from lp.soyuz.model.publishing import BinaryPackagePublishingHistory
 
 
 class DistroSeriesPackageCache(SQLBase):
@@ -102,3 +108,107 @@
                     % (cache.name, cache.id))
                 cache.destroySelf()
 
+    @classmethod
+    def updateAll(cls, distroseries, archive, log, ztm, commit_chunk=500):
+        """Update the binary package cache
+
+        Consider all binary package names published in this distro series
+        and entirely skips updates for disabled archives
+
+        :param archive: target `IArchive`;
+        :param log: logger object for printing debug level information;
+        :param ztm:  transaction used for partial commits, every chunk of
+            'commit_chunk' updates is committed;
+        :param commit_chunk: number of updates before commit, defaults to 500.
+
+        :return the number of packages updated.
+        """
+        # Do not create cache entries for disabled archives.
+        if not archive.enabled:
+            return
+
+        # Get the set of package names to deal with.
+        bpns = IStore(BinaryPackageName).find(
+            BinaryPackageName,
+            DistroArchSeries.distroseries == distroseries,
+            BinaryPackagePublishingHistory.distroarchseriesID ==
+                DistroArchSeries.id,
+            BinaryPackagePublishingHistory.archive == archive,
+            BinaryPackagePublishingHistory.binarypackagereleaseID ==
+                BinaryPackageRelease.id,
+            BinaryPackageRelease.binarypackagename == BinaryPackageName.id,
+            BinaryPackagePublishingHistory.dateremoved == None).config(
+                distinct=True).order_by(BinaryPackageName.name)
+
+        number_of_updates = 0
+        chunk_size = 0
+        for bpn in bpns:
+            log.debug("Considering binary '%s'" % bpn.name)
+            cls.update(distroseries, bpn, archive, log)
+            number_of_updates += 1
+            chunk_size += 1
+            if chunk_size == commit_chunk:
+                chunk_size = 0
+                log.debug("Committing")
+                ztm.commit()
+
+        return number_of_updates
+
+    @classmethod
+    def update(cls, distroseries, binarypackagename, archive, log):
+        """Update the package cache for a given IBinaryPackageName
+
+        'log' is required, it should be a logger object able to print
+        DEBUG level messages.
+        'ztm' is the current trasaction manager used for partial commits
+        (in full batches of 100 elements)
+        """
+        # get the set of published binarypackagereleases
+        bprs = IStore(BinaryPackageRelease).find(
+            BinaryPackageRelease,
+            BinaryPackageRelease.binarypackagename == binarypackagename,
+            BinaryPackageRelease.id ==
+                BinaryPackagePublishingHistory.binarypackagereleaseID,
+            BinaryPackagePublishingHistory.distroarchseriesID ==
+                DistroArchSeries.id,
+            DistroArchSeries.distroseries == distroseries,
+            BinaryPackagePublishingHistory.archive == archive,
+            BinaryPackagePublishingHistory.dateremoved == None)
+        bprs = bprs.order_by(Desc(BinaryPackageRelease.datecreated))
+        bprs = bprs.config(distinct=True)
+
+        if bprs.count() == 0:
+            log.debug("No binary releases found.")
+            return
+
+        # find or create the cache entry
+        cache = cls.selectOne("""
+            distroseries = %s AND
+            archive = %s AND
+            binarypackagename = %s
+            """ % sqlvalues(distroseries, archive, binarypackagename))
+        if cache is None:
+            log.debug("Creating new binary cache entry.")
+            cache = cls(
+                archive=archive,
+                distroseries=distroseries,
+                binarypackagename=binarypackagename)
+
+        # make sure the cached name, summary and description are correct
+        cache.name = binarypackagename.name
+        cache.summary = bprs[0].summary
+        cache.description = bprs[0].description
+
+        # get the sets of binary package summaries, descriptions. there is
+        # likely only one, but just in case...
+
+        summaries = set()
+        descriptions = set()
+        for bpr in bprs:
+            log.debug("Considering binary version %s" % bpr.version)
+            summaries.add(bpr.summary)
+            descriptions.add(bpr.description)
+
+        # and update the caches
+        cache.summaries = ' '.join(sorted(summaries))
+        cache.descriptions = ' '.join(sorted(descriptions))

=== modified file 'lib/lp/soyuz/stories/soyuz/xx-distributionsourcepackagerelease-pages.txt'
--- lib/lp/soyuz/stories/soyuz/xx-distributionsourcepackagerelease-pages.txt	2011-05-03 02:39:30 +0000
+++ lib/lp/soyuz/stories/soyuz/xx-distributionsourcepackagerelease-pages.txt	2011-08-23 08:33:15 +0000
@@ -252,14 +252,16 @@
     >>> from lp.services.log.logger import BufferLogger
     >>> from canonical.testing.layers import reconnect_stores
     >>> from lp.registry.interfaces.distribution import IDistributionSet
+    >>> from lp.soyuz.model.distroseriespackagecache import (
+    ...     DistroSeriesPackageCache)
     >>> login('foo.bar@canonical.com')
     >>> transaction.commit()
     >>> reconnect_stores(config.statistician.dbuser)
     >>> logger = BufferLogger()
     >>> ubuntutest = getUtility(IDistributionSet).getByName('ubuntutest')
     >>> breezy_autotest = ubuntutest.getSeries('breezy-autotest')
-    >>> unused = breezy_autotest.updateCompletePackageCache(
-    ...     ubuntutest.main_archive, logger, transaction)
+    >>> unused = DistroSeriesPackageCache.updateAll(
+    ...     breezy_autotest, ubuntutest.main_archive, logger, transaction)
     >>> transaction.commit()
     >>> reconnect_stores('launchpad')
     >>> logout()

=== modified file 'lib/lp/soyuz/tests/test_distroseriesbinarypackage.py'
--- lib/lp/soyuz/tests/test_distroseriesbinarypackage.py	2011-05-19 14:15:19 +0000
+++ lib/lp/soyuz/tests/test_distroseriesbinarypackage.py	2011-08-23 08:33:15 +0000
@@ -6,7 +6,6 @@
 __metaclass__ = type
 __all__ = [
     'TestDistroSeriesBinaryPackage',
-    'test_suite',
     ]
 
 from testtools.matchers import (
@@ -19,6 +18,7 @@
 from canonical.testing.layers import LaunchpadZopelessLayer
 from lp.services.log.logger import BufferLogger
 from lp.soyuz.model.distroseriesbinarypackage import DistroSeriesBinaryPackage
+from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.tests.test_publishing import SoyuzTestPublisher
 from lp.testing import (
     StormStatementRecorder,
@@ -61,11 +61,13 @@
         logger = BufferLogger()
         transaction.commit()
         LaunchpadZopelessLayer.switchDbUser(config.statistician.dbuser)
-        self.distroseries.updatePackageCache(
-            self.binary_package_name, distro_archive_1, logger)
+        DistroSeriesPackageCache.update(
+            self.distroseries, self.binary_package_name, distro_archive_1,
+            logger)
 
-        self.distroseries.updatePackageCache(
-            self.binary_package_name, distro_archive_2, logger)
+        DistroSeriesPackageCache.update(
+            self.distroseries, self.binary_package_name, distro_archive_2,
+            logger)
 
         self.failUnlessEqual(
             'Foo is the best', self.distroseries_binary_package.summary)

=== modified file 'lib/lp/soyuz/tests/test_publishing.py'
--- lib/lp/soyuz/tests/test_publishing.py	2011-08-15 03:41:35 +0000
+++ lib/lp/soyuz/tests/test_publishing.py	2011-08-23 08:33:15 +0000
@@ -54,6 +54,7 @@
     )
 from lp.soyuz.interfaces.queue import QueueInconsistentStateError
 from lp.soyuz.interfaces.section import ISectionSet
+from lp.soyuz.model.distroseriespackagecache import DistroSeriesPackageCache
 from lp.soyuz.model.processor import ProcessorFamily
 from lp.soyuz.model.publishing import (
     BinaryPackagePublishingHistory,
@@ -556,7 +557,8 @@
         reconnect_stores(config.statistician.dbuser)
         distroseries = getUtility(IDistroSeriesSet).get(distroseries.id)
 
-        distroseries.updateCompletePackageCache(
+        DistroSeriesPackageCache.updateAll(
+            distroseries,
             archive=distroseries.distribution.main_archive,
             ztm=transaction,
             log=DevNullLogger())

